<?php

/*
Plugin Name: Base525
Plugin URI: http://blog.kmxzblog.cn/2010/03/base525/
Description: 提供基于服务器端加密,Javascript解密的加密传输方案.您需要进行设置方可使用.
Version: 0.1
Author: kmxz
Author URI: http://kmxzblog.cn/
*/

//--获取插件目录--

$b525_dir = dirname( __FILE__ );
$b525_dir_url = get_bloginfo('wpurl').'/wp-content/plugins/base525';

//--首次运行--

add_option('b525_cryption', 'base64');
add_option('b525_encode', array());
add_option('b525_ua_list', array('Googlebot','msnbot','Baiduspider','ia_archiver','Yahoo'));
add_option('b525_js_warn', '<div style="background-color:#FCC;color:#000;padding:5px;border:1px #F00 solid;font-size:14px;font-weight:bold;width:500px;margin:auto">对不起，您的浏览器不支持JavaScript，将无法正常浏览本站，请理解!</div>');

//--初始化--

define('B525_CRYPTION',get_settings('b525_cryption'));

//--后台管理--
add_action('admin_menu', 'b525_plugin_menu');

function b525_plugin_menu() {
  add_options_page('Base525 Options', 'Base525 选项', 9, 'b525', 'b525_plugin_options');
}

function b525_lib_list($selected) { //获取加密函数文件
  global $b525_dir;
  $dir_handle=opendir($b525_dir);
  while($file=readdir($dir_handle)) {
	$file = $b525_dir.'/'.$file;
    if (filetype($file) == 'file'){
	  $file = basename($file);
      if ((substr($file,0,4)=='lib-')&&(substr($file,-4)=='.php')){
	    $encname = substr($file,4,-4);
        echo '<option value="'.$encname.'"';
	    if ($file==$selected.'.php'){ echo ' selected="selected"'; }
	    echo '>'.$encname.'</option>';
      }
    }
  }	
}

function devide_by_line($str) { //按行分割
  if($str=='')return array();
  $nstr = explode("\r\n",$str);
  if(sizeof($nstr)==1){ $nstr = explode("\r",$str);	}
  if(sizeof($nstr)==1){ $nstr = explode("\n",$str);	}
  return $nstr;
}

function b525_checkbox($value) {
  global $b525_encodes;
  if (in_array($value,$b525_encodes)) {
	echo 'checked="checked" ';  
  }
  echo 'value="'.$value.'"';
}

function b525_plugin_options() {
  global $b525_encodes;
	
  if (isset($_POST['update_b525'])) {
    update_option('b525_cryption', 'lib-'.$_POST['b525_cryption']);
    update_option('b525_encode', $_POST['b525_encode']);
	update_option('b525_ua_list', devide_by_line(stripslashes($_POST['b525_ua_list']))); 
	update_option('b525_js_warn', stripslashes($_POST['b525_js_warn']));
	
	echo '<div class="updated"><p><strong>Base525设置已更改</strong></p></div>';
  }
	
  $b525_encodes=get_settings('b525_encode');
	
?>
<div class="wrap">
  <h2>Base525 选项</h2>
  <div class="wrap">
  提示：<ol><li>所有主题、内容请使用UTF-8编码</li><li>替代的摘要函数默认摘取200个汉字,具体可在<code>excerpt.php</code>中修改</li><li>据传根据搜索引擎User-Agent给出不同内会受到搜索引擎惩罚,所以请慎用!</li></ol>  
  </div><br />
  <form method="post">
  <h3>加密方式</h3>
   <div class="wrap">
     <select name="b525_cryption"><?php b525_lib_list(get_settings('b525_cryption')); ?></select> <span class="description">您可以参照<code>lib-base64.php</code>中的说明添加其它加密方式</span>
   </div><br />
  <h3>加密项目</h3>
    <div class="wrap">
     <input type="checkbox" name="b525_encode[]" <?php b525_checkbox('title'); ?> />文章标题<br />
     <input type="checkbox" name="b525_encode[]" <?php b525_checkbox('content'); ?> />文章内容 <span class="description">开启此项后WP自带摘要函数将被替换,所有有关摘要的Filter将失效!</span><br />
     <input type="checkbox" name="b525_encode[]" <?php b525_checkbox('comment'); ?> />评论内容<br />
     <input type="checkbox" name="b525_encode[]" <?php b525_checkbox('submit'); ?> />评论上传 <span class="description">对评论先加密再提交至服务器,服务器再执行解密操作</span><br />
    </div><br />
  <h3>杂项</h3>
   <div class="wrap">
     User-Agent排除名单(每行一个,留空禁用)<br /><span class="description">如果遇到包含以下关键词之一的User-Agent,则不加密(便于搜索引擎收录)</span><br />
     <textarea name="b525_ua_list" cols="80" rows="5"><?php echo implode("\r\n",get_settings('b525_ua_list')); ?></textarea> 
   <br /><br />
     对不支持Javascript的用户的警告内容(留空禁用)<br /><span class="description">默认使用<code>get_footer</code>钩子显示警告</span><br />
     <textarea name="b525_js_warn" cols="80" rows="5"><?php echo get_settings('b525_js_warn'); ?></textarea> 
   </div><br />
   <p class="submit"><input type="submit" value="保存设置" class="button-primary" name="update_b525" /></p>
   </form>
</div>
<?php
}

//--判断是否启用--

function b525_in_ua_list($ua) {
  $b525_ual = get_settings('b525_ua_list');
  if (sizeof($b525_ual)!=0) {
    foreach ($b525_ual as $b525_ilu) {
      if (strpos($ua,$b525_ilu)){ return false; }
	}
  return true;
  }
}

define('B525DO',b525_in_ua_list($_SERVER['HTTP_USER_AGENT']));

//--一些函数--

function b525_nojs_warn() {
  $warn_content=get_settings('b525_js_warn');
  if ($warn_content=='') { return; }
  echo '<noscript>'.$warn_content;
?>
</noscript>
<?php
}

function b525_core($str) {
  if( (is_admin()) || (is_feed()) ) { return $str; }
  $str = '<script language="javascript">document.write(b525Dec("'.b525_enc($str).'"));</script>';
  return $str;
}

function b525_js() {
  global $b525_dir_url;
  echo '<script language="javascript" src="'.$b525_dir_url.'/'.B525_CRYPTION.'.js"></script>';
}

function b525_comment_form() {
  echo '<div id="b525cfl"></div>';
}

function b525_form_js() {
?>
<script language="javascript">
function findFormParent(el) {
  var nf = el.parentNode;
  while (nf.tagName.toLowerCase() != "form") { nf = nf.parentNode; }
  return nf;
}
var b525Ca = document.getElementById("b525cfl");
if (b525Ca != null) {
  var b525Cf = findFormParent(b525Ca);
  var b525Cc = document.getElementsByName("comment");
  var b525Cr = b525Cc[0];
  for (var i=1;i<b525Cc.length;i++) {
    if ( findFormParent(b525Cc[i])==b525Cf) { b525Cr = b525Cc[i]; }
  }
  if ((b525Cr.value.slice(0,3)=="-B-")&&(b525Cr.value.slice(-3)=="-E-")) { b525Cr.value=b525Dec(b525Cr.value.slice(3,-3)) }
  b525Cf.onsubmit = function () {
    b525Cr.value = '-B-'+b525Enc(b525Cr.value)+'-E-';
  }
}
</script>
<?php
}

function b525_comment_server($com) {
  if (( substr($com,0,3)=='-B-' )&&( substr($com,-3)=='-E-' )) {
	$com = b525_dec(substr($com,3,-3));
  }
  return $com;
}

//--添加Action/Filter

if(B525DO){
  require_once($b525_dir.'/'.B525_CRYPTION.'.php');
  add_action('wp_head','b525_js');
  add_action('get_footer','b525_nojs_warn');
  $b525_encodes=get_settings('b525_encode');
  if (in_array('content',$b525_encodes)) {
	require_once($b525_dir.'/excerpt.php');
    add_filter('the_content','b525_core');
    add_filter('the_excerpt','b525_core');
  }
  if (in_array('title',$b525_encodes)) {
    add_filter('the_title','b525_core');
  }
  if (in_array('comment',$b525_encodes)) {
    add_filter('comment_text','b525_core');
  }
  if (in_array('submit',$b525_encodes)) {
    add_action('comment_form','b525_comment_form');
    add_action('get_footer','b525_form_js');
    add_filter('pre_comment_content','b525_comment_server');
  }
}

?>


